Error obtaining the Geometry of a Helical Staircase

I’m having problems with obtaining its geometry.
Works fine with non-helical staircases but not with helical ones.

Also tried RevitAPI methods to no avail.

import clr
clr.AddReference('ProtoGeometry')
from Autodesk.DesignScript.Geometry import *
clr.AddReference('RevitAPI')
import Autodesk.Revit.DB as DB

clr.AddReference('RevitNodes')
import Revit
clr.ImportExtensions(Revit.Elements)
clr.ImportExtensions(Revit.GeometryConversion)

stair = UnwrapElement(IN[0])
opts = DB.Options()
geom = stair.get_Geometry(opts)

inst_geom = [g.GetInstanceGeometry() for g in geom]

flattened = [item for sublist in inst_geom for item in sublist]

OUT = [i.ToProtoType() for i in flattened]


Errors:
image

image

Dynamo’s geometry conversion process has difficulties with elliptical and helical face edge loops. If you’re feeling adventurous, one thing you can try out is using the mesh geometry node from the latest version of spring nodes and convert the output to a polysurface. You can then use the PS as is or try to pull out solids from it:

![Revit_2018-04-07_20-59-46|690x371](upload://jBhRR6wbvM9SX2oMCE5ZyEYqM4A.png

It’s not a sturdy solution but might just get you as far as you need…

Thanks a bunch, I’ll try this out.